using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;
using System.Xml;
using System.Xml.XPath;

namespace Enfold.Templates
{
	/// <summary>
	/// Summary description for main_frame.
	/// </summary>
	public class main_frame : System.Web.UI.Page
	{
		protected string uid = "";
		protected string body = "";
		protected System.Web.UI.WebControls.Repeater rptrEvents;
		protected System.Web.UI.WebControls.Repeater rptrNews;
		protected System.Web.UI.WebControls.Repeater rptrSiblings;
		protected Hashtable pageData = null;
		protected string ploneFilePath = "";
	
		private void Page_Load(object sender, System.EventArgs e)
		{
			// Put user code to initialize the page here
			//get _uid and body from .data RPC file.
			//bind our repeaters....
			//no error handling yet...
			try 
			{
				ploneFilePath = GetPloneFileName();
				pageData = Enfold.Framework.EntransitUtilities.LoadPropertiesFromXML(ploneFilePath);
			} 
			catch (System.IO.FileNotFoundException) 
			{
				// xxx - what to do?
				System.Diagnostics.Trace.WriteLine(String.Format("Could not locate file {0}", ploneFilePath));
				return;
			}
			catch (System.Exception exc) 
			{
				Response.Write(exc.ToString());
				Response.End();
			}
			try	{
				uid = pageData["uid"].ToString();
				body = pageData["body"].ToString();
				rptrEvents.DataSource = GetEvents();
				rptrEvents.DataBind();
				rptrNews.DataSource = GetNews();
				rptrNews.DataBind();
				rptrSiblings.DataSource = GetSiblings();
				rptrSiblings.DataBind();
			}
			catch (System.Exception ex) {
				//very simple, just write the real error message to the browser..  we can format this nicely later ;)
				Response.Write(ex.Message);
				Response.Flush();
				Response.End();
			}
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{    
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion

		private string GetPloneFileName(){
			if(this.Context.Items.Contains(ConfigSettings.PlonePathKeyName)){
				return this.Context.Items[ConfigSettings.PlonePathKeyName].ToString();
			}
			else{
				return Server.MapPath(String.Concat(Request.Path, Enfold.ConfigSettings.GetInstance().PloneDataExtension));
			}
		}

		private Enfold.Framework.ContentItemsCollection GetEvents(){
			return Enfold.Framework.ContentItem.GetPublishedItemsByType("Event");
		}

		private Enfold.Framework.ContentItemsCollection GetNews() {
			return Enfold.Framework.ContentItem.GetPublishedItemsByType("News Item");
		}

		private Enfold.Framework.ContentItemsCollection GetSiblings() {
			return Enfold.Framework.ContentItem.GetSiblingContentItems(uid);
		}

		protected  string MakeRelative (string toPath){
			string rel = Enfold.Framework.EntransitUtilities.MakeRelative(toPath, Enfold.ConfigSettings.GetInstance().EntransitDeploymentDirectory);
			return rel;
		}
		
	}
}
